package view;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import model.Dessin;
import model.Etoile;
import model.Figure;
import model.Trace;
import controller.EcouteurCrayon;
import controller.EcouteurEtoile;
import controller.EcouteurSouris;

public class AppletDeDessin
		extends Applet
		implements KeyListener {
	private Dessin dessin;
	private EcouteurCrayon crayon;
	private EcouteurEtoile etoile;
	private EcouteurSouris courant;

	/* en tant qu'Applet */
	public String getAppletInfo() {
		return "Applet de dessin.";
	}

	public void init() {
		dessin = new Dessin();
		crayon = new EcouteurCrayon(dessin, this);
		etoile = new EcouteurEtoile(dessin, this);
		courant = crayon;
		addMouseListener(crayon);
		addMouseMotionListener(crayon);
		addKeyListener(this);
	}

	public void changerOutil(EcouteurSouris outil) {
		removeMouseListener(courant);
		removeMouseMotionListener(courant);
		addMouseListener(outil);
		addMouseMotionListener(outil);
		courant = outil;
	}

	public void dessineTrait(int x1, int y1, int x2, int y2) {
		Graphics g = getGraphics();
		g.drawLine(x1, y1, x2, y2);
	}

	public void dessineFigure(Figure figure, Graphics g) {
	}

	public void dessineFigure(Trace trace, Graphics g) {
		Point pt = trace.element(0);
		int xd, yd, x, y;
		xd = (int) (pt.getX());
		yd = (int) (pt.getY());
		for (int numPt = 1; numPt < trace.nbPoints(); numPt++) {
			pt = trace.element(numPt);
			x = (int) (pt.getX());
			y = (int) (pt.getY());
			g.drawLine(xd, yd, x, y);
			xd = x;
			yd = y;
		}
	}

	public void dessineFigure(Etoile etoile, Graphics g) {
		Point pt = etoile.centre();
		int xc, yc, x, y;
		xc = (int) (pt.getX());
		yc = (int) (pt.getY());
		for (int numPt = 0; numPt < etoile.nbPoints(); numPt++) {
			pt = etoile.element(numPt);
			x = (int) (pt.getX());
			y = (int) (pt.getY());
			g.drawLine(xc, yc, x, y);
		}
	}

	public void paint(Graphics g) {
		for (int numFig = 0; numFig < dessin.nbFigures(); numFig++) {
			dessineFigure(dessin.element(numFig), g);
		}
	}

	/* en tant que KeyListener */
	public void keyPressed(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
		switch (e.getKeyChar()) {
		case 'e':
			changerOutil(etoile);
			break;
		case 'c':
			changerOutil(crayon);
			break;
		}
	}
}